//---------------------------------------------------------------------------
// Roman Brik, TE010062, 2. ronk DI, KPI FEI TU Koice
// Dtum: Marec - Mj 2003
// Predmet: Objektovo orientovan programovanie
// Sbor: Find.cpp - zdrojov kd formulru pre vyhadvanie
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Tovar.h"
#include "Hudba.h"
#include "Main.h"
#include "Find.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormFind *FormFind;
//---------------------------------------------------------------------------
__fastcall TFormFind::TFormFind(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormFind::FormShow(TObject *Sender)
{
  WORD wY, wM, wD;

  DecodeDate(Now(), wY, wM, wD);
  ComboBoxMesiac->ItemIndex = wM - 1;

  ZoznamAlbumov = new TList;

  ComboBoxMesiacChange(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TFormFind::FormClose(TObject *Sender, TCloseAction &Action)
{
  VyprazdniZoznamAlbumov();
  delete ZoznamAlbumov;
}
//---------------------------------------------------------------------------
void __fastcall TFormFind::ButtonZrusitClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TFormFind::ComboBoxMesiacChange(TObject *Sender)
{
  int ii;
  Nakup *NZ;
  PolozkaNakupu *PN;

  VyprazdniZoznamAlbumov();
  for (ii = 0; ii < MainForm->Odd->ZoznamNakupov->Count; ii++) {
    NZ = MainForm->Odd->FindNakup(ComboBoxMesiac->ItemIndex + 1, ii);
    if (NZ != NULL)
      for (int ix = 0; ix < NZ->ZoznamNakupu->Count; ix++)
        PridajAlbum((PolozkaNakupu *)NZ->ZoznamNakupu->Items[ix]);
  }

  if (ZoznamAlbumov->Count == 0) {
    StaticTextNazov->Caption = "Nenjden";
    StaticTextMnozstvo->Caption = "";
  }
  else {
    int ia = 0;
    float fm = 0;
    for (ii = 0; ii < ZoznamAlbumov->Count; ii++) {
      PN = (PolozkaNakupu *)ZoznamAlbumov->Items[ii];
      if (PN->Mnozstvo > fm) {
        fm = PN->Mnozstvo;
        ia = ii;
      }
    }
    PN = (PolozkaNakupu *)ZoznamAlbumov->Items[ia];
    StaticTextNazov->Caption = PN->Nazov;
    StaticTextMnozstvo->Caption = FloatToStr(PN->Mnozstvo) + " ks";
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormFind::PridajAlbum(PolozkaNakupu *PA)
{
  PolozkaNakupu *PQ;

  for (int iy = 0; iy < ZoznamAlbumov->Count; iy++) {
    PQ = (PolozkaNakupu *)ZoznamAlbumov->Items[iy];
    if (PA->Nazov.AnsiCompare(PQ->Nazov) == 0) {
      PQ->Mnozstvo += PA->Mnozstvo;
      return;
    }
  }
  PQ = new PolozkaNakupu;
  PQ->Nazov = PA->Nazov;
  PQ->Mnozstvo = PA->Mnozstvo;
  ZoznamAlbumov->Add(PQ);
}
//---------------------------------------------------------------------------
void __fastcall TFormFind::VyprazdniZoznamAlbumov()
{
  PolozkaNakupu *XP;

  for (int i = 0; i < ZoznamAlbumov->Count; i++) {
    XP = (PolozkaNakupu *)ZoznamAlbumov->Items[i];
    delete XP;
  }
  ZoznamAlbumov->Clear();
}
//---------------------------------------------------------------------------

