//---------------------------------------------------------------------------
// Roman Brik, TE010062, 2. ronk DI, KPI FEI TU Koice
// Dtum: Marec - Mj 2003
// Predmet: Objektovo orientovan programovanie
// Sbor: Tovar.h - hlavikov sbor abstraktnej triedy Tovar
//---------------------------------------------------------------------------
#ifndef TovarH
#define TovarH
//---------------------------------------------------------------------------
#define MAX_ZARUKA_ITEMS 21 // pocet "zarucnych dob" vratane prveho "Bez zaruky"
enum TGT {GT_TEXT, GT_INDEX, GT_VALUE};
//---------------------------------------------------------------------------
// Abstraktna trieda Tovar
class Tovar {
private: // clenske premenne viditelne len metodami tejto triedy
  AnsiString Nazov;
  float NakupnaCenaBezDPH;
  float PredajnaCenasDPH;
  TDateTime DatumVyroby;
  int ZarucnaDoba;               // v dnoch
  float Mnozstvo;
  AnsiString MernaJednotka;
  float JednotkovaCena;
  int Zaruka[MAX_ZARUKA_ITEMS];  // pole so zarucnymi dobami v dnoch

public:
// konstruktor
  __fastcall Tovar();

// ciste virtualne metody
  virtual AnsiString __fastcall getOddelenie()=0;
  virtual AnsiString __fastcall getDruh()=0;

// clenske metody
  AnsiString __fastcall getZarucnaDoba(TGT gtZD, int &iZD);
  bool __fastcall setZarucnaDoba(TGT gtZD, int iZD);
  void __fastcall setNazov(AnsiString Nazov);
  AnsiString __fastcall getNazov();
  void __fastcall setNakupnaCenaBezDPH(float NakupnaCenaBezDPH);
  float __fastcall getNakupnaCenaBezDPH();
  void __fastcall setPredajnaCenasDPH(float PredajnaCenasDPH);
  float __fastcall getPredajnaCenasDPH();
  void __fastcall setDatumVyroby(TDateTime DatumVyroby);
  TDateTime __fastcall getDatumVyroby();
  void __fastcall setMnozstvo(float Mnozstvo);
  float __fastcall getMnozstvo();
  void __fastcall setMernaJednotka(AnsiString MernaJednotka);
  AnsiString __fastcall getMernaJednotka();
  void __fastcall setJednotkovaCena(float JednotkovaCena);
  float __fastcall getJednotkovaCena();
};
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------

